package x64

import (
	"encoding/binary"

	"git.akyoto.dev/cli/q/src/build/cpu"
)

// MoveRegisterNumber32 moves a 32 bit integer into the given register.
func MoveRegisterNumber32(code []byte, destination cpu.Register, number uint32) []byte {
	if destination > 0b111 {
		code = append(code, REX(0, 0, 0, 1))
		destination &= 0b111
	}

	code = append(code, 0xb8+byte(destination))
	return binary.LittleEndian.AppendUint32(code, number)
}

// MoveRegisterRegister64 moves a register value into another register.
func MoveRegisterRegister64(code []byte, destination cpu.Register, source cpu.Register) []byte {
	return encode(code, AddressDirect, source, destination, 8, 0x89)
}
