package x64_test

import (
	"math"
	"testing"

	"git.akyoto.dev/cli/q/src/build/arch/x64"
	"git.akyoto.dev/go/assert"
)

func TestSizeOf(t *testing.T) {
	assert.Equal(t, x64.SizeOf(0), 1)
	assert.Equal(t, x64.SizeOf(math.MinInt8), 1)
	assert.Equal(t, x64.SizeOf(math.MaxInt8), 1)
	assert.Equal(t, x64.SizeOf(math.MinInt16), 2)
	assert.Equal(t, x64.SizeOf(math.MaxInt16), 2)
	assert.Equal(t, x64.SizeOf(math.MinInt32), 4)
	assert.Equal(t, x64.SizeOf(math.MaxInt32), 4)
	assert.Equal(t, x64.SizeOf(math.MinInt64), 8)
	assert.Equal(t, x64.SizeOf(math.MaxInt64), 8)
}
